/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARKMW_COLLECTOR_H_INCLUDED)
#define HARKMW_COLLECTOR_H_INCLUDED 1

#include <hark-base/BufferedNode.h>

namespace HARK
{
    class HARKMW_Collector : public BufferedNode
    {
    public:
	HARKMW_Collector(const std::string &nodeName, const HARK::ParameterSet &params);

    public:
	virtual void initialize();

	virtual ObjectRef getOutput(int output_id, int count);

	virtual ObjectRef getOutputNamed (const std::string &outputName, int count);

	virtual bool hasOutput(int output_id) const;

	virtual void request(int outputID, const ParameterSet &req);

	virtual void requestAll(const ParameterSet &req);

virtual void calculate(int output_id, int count, Buffer &buf);

	ObjectRef getOutput(int outputID, int input_count, int output_count);
	ObjectRef getOutputNamed(const std::string &outputName, int input_count, int output_count);

    protected:
	virtual int translateInput(const std::string &inputName);
	virtual int translateOutput(const std::string &inputName);

    private:
	int last_input_count;
	int last_output_count;
  std::map<int, int> out2inMap;

  // IN_ORDER_NODE_SPEEDUP(HARKMW_Collector);
    };
}

#endif

/* end of file */
